﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Jdas_Mbic
{
    public partial class JdasMbic : Form
    {
        const double Table_Dbm_DefaultValue = 31.5;
        const int Table_DL_DefaultValue = 5;
        const int Table_UL_DefaultValue = -15;
        const int Table_Temp_DefaultValue = -10;

        enum DLUL_Category
        {
            DL_DET = 0,
            UL_DET
        };


        public JdasMbic()
        {
            InitializeComponent();
        }

        private void JdasMbic_Load(object sender, EventArgs e)
        {
            ATT_TableLayoutSetting();
        }
        
        private void ATT_TableLayoutSetting()
        {
            double TempDbmData = Table_Dbm_DefaultValue;
            string tempstr = "";
            for (int i = 0; i < 64; i++)
            {
                dataGridView_TableSetting.Rows.Add();
                tempstr = string.Format("{0:0.0}", TempDbmData);
                dataGridView_TableSetting[0, i].Value = Convert.ToString(tempstr) + " dBm"; ;
                TempDbmData = TempDbmData - 0.5;
                
            }

            foreach (DataGridViewRow row in this.dataGridView_TableSetting.Rows)
            {
                row.HeaderCell.Value = String.Format("{0}", row.Index + 1);
            }
            this.dataGridView_TableSetting.AutoResizeRowHeadersWidth(
            DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders);
            this.dataGridView_TableSetting.TopLeftHeaderCell.Value = "No.";
            dataGridView_TableSetting.Columns[0].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView_TableSetting.ClearSelection();
        }


        private void DET_TableLayoutSetting(DLUL_Category cat)
        {
            string tempstr = "";
            DLUL_Category tempenum = cat;

            switch (tempenum) {
                case DLUL_Category.DL_DET:
                    double Temp_DL_Data = Table_DL_DefaultValue;
                    for (int i = 0; i < 31; i++)
                    {
                        dataGridView_TableSetting.Rows.Add();
                        tempstr = string.Format("{0:0}", Temp_DL_Data);
                        dataGridView_TableSetting[0, i].Value = Convert.ToString(tempstr) + " dBm";
                        Temp_DL_Data = Temp_DL_Data - 1;

                    }
                    break;
                case DLUL_Category.UL_DET:
                    double Temp_UL_Data = Table_UL_DefaultValue;
                    for (int i = 0; i < 46; i++)
                    {
                        dataGridView_TableSetting.Rows.Add();
                        tempstr = string.Format("{0:0}", Temp_UL_Data);
                        dataGridView_TableSetting[0, i].Value = Convert.ToString(tempstr) + " dBm";
                        Temp_UL_Data = Temp_UL_Data - 1;

                    }
                    break;
            }
            
        }
        private void Temp_TableLayoutSetting()
        {
            string tempstr = "";
            
            double Temp_Data = Table_Temp_DefaultValue;
            for (int i = 0; i < 46; i++)
            {
                dataGridView_TableSetting.Rows.Add();
                tempstr = string.Format("{0:0}", Temp_Data);
                dataGridView_TableSetting[0, i].Value = Convert.ToString(tempstr) + " ℃";
                Temp_Data = Temp_Data - 1;

            }
            foreach (DataGridViewRow row in this.dataGridView_TableSetting.Rows)
            {
                row.HeaderCell.Value = String.Format("{0}", row.Index + 1);
            }
            this.dataGridView_TableSetting.AutoResizeRowHeadersWidth(
            DataGridViewRowHeadersWidthSizeMode.AutoSizeToAllHeaders);
            this.dataGridView_TableSetting.TopLeftHeaderCell.Value = "No.";
            dataGridView_TableSetting.Columns[0].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter;
            dataGridView_TableSetting.ClearSelection();
        }

        private void dataGridView_TableSetting_CellClick(object sender, DataGridViewCellEventArgs e)
        {

        }
        /*
         * 
         * TABLE Setting Area
         * 
         */
        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            ComboBox comboBox = (ComboBox)sender;
            string tempstr = comboBox.Text;

            switch (tempstr)
            {
                case "ATT_DL1":
                case "ATT_UL1": 
                case "ATT_DL2": 
                case "ATT_UL2": 
                case "ATT_DL3": 
                case "ATT_UL3": 
                case "ATT_DL4": 
                case "ATT_UL4": 
                    dataGridView_TableSetting.Rows.Clear();
                    ATT_TableLayoutSetting();
                    break;
                case "DET_DL1": 
                case "DET_DL2": 
                case "DET_DL3": 
                case "DET_DL4":
                    dataGridView_TableSetting.Rows.Clear();
                    DET_TableLayoutSetting(DLUL_Category.DL_DET);
                    break;
                case "DET_UL1": 
                case "DET_UL2": 
                case "DET_UL3": 
                case "DET_UL4":
                    dataGridView_TableSetting.Rows.Clear();
                    DET_TableLayoutSetting(DLUL_Category.UL_DET);
                    break;
                case "TEMP_DL1": 
                case "TEMP_UL1": 
                case "TEMP_DL2": 
                case "TEMP_UL2": 
                case "TEMP_DL3": 
                case "TEMP_UL3": 
                case "TEMP_DL4": 
                case "TEMP_UL4": 
                    dataGridView_TableSetting.Rows.Clear();
                    Temp_TableLayoutSetting();
                    break;
                default:
                    MessageBox.Show("존재하지 않는 ComboBox 입니다.\r\n 확인해주세요.");
                    break;
            }
           
                
        }

        private void button_MultiSet_Click(object sender, EventArgs e)
        {
            Int32 selectedCellCount =
            dataGridView_TableSetting.GetCellCount(DataGridViewElementStates.Selected);
            if (selectedCellCount > 0)
            {
                if (dataGridView_TableSetting.AreAllCellsSelected(true))
                {
                    MessageBox.Show("All cells are selected", "Selected Cells");
                }
                else
                {
                    System.Text.StringBuilder sb =
                        new System.Text.StringBuilder();

                    for (int i = 0;
                        i < selectedCellCount; i++)
                    {
                        sb.Append("Row: ");
                        sb.Append(dataGridView_TableSetting.SelectedCells[i].RowIndex
                            .ToString());
                        sb.Append(", Column: ");
                        sb.Append(dataGridView_TableSetting.SelectedCells[i].ColumnIndex
                            .ToString());
                        sb.Append(Environment.NewLine);
                    }

                    sb.Append("Total: " + selectedCellCount.ToString());
                    MessageBox.Show(sb.ToString(), "Selected Cells");
                }
            }
        }
    }
}
